<template>
  <div>
    <v-row>
      <v-col :cols="12" :sm="12" :md="3" :lg="3" :xl="3">
        <Codificacion v-model="dataCodificacion" />
      </v-col>
      <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
        <Pais v-model="dataPais" />
      </v-col>
      <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
        <Modelo v-model="dataModelo" />
      </v-col>
      <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
        <UnidadNegocio v-model="dataUnidadNegocio" />
      </v-col>
      <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
        <NivelPaso v-model="dataNivelPaso" :nivel="2" @loadData="loadData" />
      </v-col>
      <v-col
        :cols="12"
        :sm="12"
        :md="2"
        :lg="2"
        :xl="2"
        v-if="dataNivelPaso.value && dataNivelPaso.value.hasChildren"
      >
        <NivelMacroproceso
          v-model="dataNivelMacroproceso"
          :nivel="3"
          :nodes="dataNiveles"
          :idModeloNegocioPadre="dataNivelPaso.value.idArbol"
        />
      </v-col>
      <v-col
        :cols="12"
        :sm="12"
        :md="2"
        :lg="2"
        :xl="2"
        v-if="
          dataNivelMacroproceso.value && dataNivelMacroproceso.value.hasChildren
        "
      >
        <NivelProceso
          v-model="dataNivelProceso"
          :nivel="4"
          :nodes="dataNiveles"
          :idModeloNegocioPadre="dataNivelMacroproceso.value.idArbol"
        />
      </v-col>
      <v-col
        :cols="12"
        :sm="12"
        :md="2"
        :lg="2"
        :xl="2"
        v-if="dataNivelProceso.value && dataNivelProceso.value.hasChildren"
      >
        <NivelElemento
          v-model="dataNivelElemento"
          :nivel="5"
          :nodes="dataNiveles"
          :idModeloNegocioPadre="dataNivelProceso.value.idArbol"
        />
      </v-col>
    </v-row>
  </div>
</template>
<script>
import { required } from "vuelidate/lib/validators";
import Codificacion from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Codificacion.vue";
import Pais from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Pais.vue";
import Modelo from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Modelo.vue";
import UnidadNegocio from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/UnidadNegocio.vue";
import NivelPaso from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Nivel.vue";
import NivelMacroproceso from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Nivel.vue";
import NivelProceso from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Nivel.vue";
import NivelElemento from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/rutas/componentes/elementos/Nivel.vue";
export default {
  name: "Component-Rutas",
  components: {
    Codificacion,
    Pais,
    Modelo,
    UnidadNegocio,
    NivelPaso,
    NivelMacroproceso,
    NivelProceso,
    NivelElemento,
  },
  props: ["value"],
  data() {
    return {
      dataCodificacion: {
        value: null,
        validator: null,
      },
      dataPais: {
        value: null,
        validator: null,
      },
      dataModelo: {
        value: null,
        validator: null,
      },
      dataUnidadNegocio: {
        value: null,
        validator: null,
      },
      dataNiveles: [],
      dataNivelPaso: {
        value: null,
        validator: null,
        params: {
          descripcion: "Paso",
          idNivel: 2,
        },
      },
      dataNivelMacroproceso: {
        value: null,
        validator: null,
        params: {
          descripcion: "Nivel 1",
          idNivel: 3,
        },
      },
      dataNivelProceso: {
        value: null,
        validator: null,
        params: {
          descripcion: "Nivel 2",
          idNivel: 4,
        },
      },
      dataNivelElemento: {
        value: null,
        validator: null,
        params: {
          descripcion: "Nivel 3",
          idNivel: 5,
        },
      },
    };
  },
  validations: {
    dataCodificacion: {
      value: {
        required,
      },
    },
    dataPais: {
      value: {
        required,
      },
    },
    dataModelo: {
      value: {
        required,
      },
    },
    dataUnidadNegocio: {
      value: {
        required,
      },
    },
    dataNivelPaso: {
      value: {
        required,
      },
    },
    dataNivelMacroproceso: {
      value: {
        required: function(element) {
          if (element && element.idArbol) {
            return true;
          } else {
            if (this.dataNivelPaso.value && this.dataNivelPaso.value.idArbol) {
              return !this.dataNivelPaso.value.hasChildren;
            } else {
              return false;
            }
          }
        },
      },
    },
    dataNivelProceso: {
      value: {
        required: function(element) {
          if (element && element.idArbol) {
            return true;
          } else {
            if (
              this.dataNivelMacroproceso.value &&
              this.dataNivelMacroproceso.value.idArbol
            ) {
              return !this.dataNivelMacroproceso.value.hasChildren;
            } else {
              return false;
            }
          }
        },
      },
    },
    dataNivelElemento: {
      value: {
        required: function(element) {
          if (element && element.idArbol) {
            return true;
          } else {
            if (
              this.dataNivelProceso.value &&
              this.dataNivelProceso.value.idArbol
            ) {
              return !this.dataNivelProceso.value.hasChildren;
            } else {
              return true;
            }
          }
        },
      },
    },
  },
  watch: {
    "dataNivelPaso.value": {
      deep: true,
      handler(val) {
        this.dataNivelMacroproceso.value = {};
        this.dataNivelProceso.value = {};
        this.dataNivelElemento.value = {};
      },
    },
    "dataNivelMacroproceso.value": {
      deep: true,
      handler(val) {
        this.dataNivelProceso.value = {};
        this.dataNivelElemento.value = {};
      },
    },
    "dataNivelProceso.value": {
      deep: true,
      handler(val) {
        this.dataNivelElemento.value = {};
      },
    },
  },
  computed: {
    data: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  methods: {
    loadData(event) {
      this.dataNiveles = event;
    },
  },
  created() {
    this.value.dataCodificacion = this.dataCodificacion;
    this.value.dataPais = this.dataPais;
    this.value.dataModelo = this.dataModelo;
    this.value.dataUnidadNegocio = this.dataUnidadNegocio;
    this.value.dataNivelPaso = this.dataNivelPaso;
    this.value.dataNivelMacroproceso = this.dataNivelMacroproceso;
    this.value.dataNivelProceso = this.dataNivelProceso;
    this.value.dataNivelElemento = this.dataNivelElemento;

    this.dataCodificacion.validator = this.$v.dataCodificacion.value;
    this.dataPais.validator = this.$v.dataPais.value;
    this.dataModelo.validator = this.$v.dataModelo.value;
    this.dataUnidadNegocio.validator = this.$v.dataUnidadNegocio.value;
    this.dataNivelPaso.validator = this.$v.dataNivelPaso.value;
    this.dataNivelMacroproceso.validator = this.$v.dataNivelMacroproceso.value;
    this.dataNivelProceso.validator = this.$v.dataNivelProceso.value;
    this.dataNivelElemento.validator = this.$v.dataNivelElemento.value;
  },
};
</script>
